AceBuffGroup = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0")
local L = AceLibrary("AceLocale-2.2"):new("AceBuffGroup")
local BS = AceLibrary("Babble-Spell-2.2")
local BC = AceLibrary("Babble-Class-2.2")
local metro = AceLibrary("Metrognome-2.0")
local schedule = 1

AceBuffGroup:RegisterChatCommand({ "/abg", "/acebuffgroups" }, {
    type = 'group',
    args = {
        show = {
            name = "Show the Dialog",
            desc = "Show the Dialog",
            type = 'execute',
            func = function()
		        AGBMainWindow:Show();
    		end,
        }
    }
})

AceBuffGroupDB = {}
AceBuffGroupDB.Priest = {}
AceBuffGroupDB.Priest.Stamina = {}
AceBuffGroupDB.Priest.Spirit = {}
AceBuffGroupDB.Priest.Shadow = {}
AceBuffGroupDB.Mage = {}
AceBuffGroupDB.Paladin = {}
AceBuffGroupDB.Druid = {}

AGB_HASSPIRIT = {}



AGB_LOCALS ={}
AGB_LOCALS.gotw = BS["Gift of the Wild"]..":"
AGB_LOCALS.ai = BS["Arcane Brilliance"]..":"
AGB_LOCALS.Stamina = L["Stamina"]..":"
AGB_LOCALS.Spirit = L["Spirit"]..":"
AGB_LOCALS.Shadow = L["Shadowprotection"]..":"
AGB_LOCALS.BOK = BS["Blessing of Kings"]..":"
AGB_LOCALS.BOW = BS["Blessing of Wisdom"]..":"
AGB_LOCALS.BOM = BS["Blessing of Might"]..":"
AGB_LOCALS.BOSAL = BS["Blessing of Salvation"]..":"
AGB_LOCALS.BOSAN = BS["Blessing of Sanctuary"]..":"
AGB_LOCALS.BOL = BS["Blessing of Light"]..":"
AGB_LOCALS.SOW = BS["Seal of Wisdom"]..":"
AGB_LOCALS.SOL = BS["Seal of Light"]..":"
AGB_LOCALS.g1 = L["Group"].." 1:"
AGB_LOCALS.g2 = L["Group"].." 2:"
AGB_LOCALS.g3 = L["Group"].." 3:"
AGB_LOCALS.g4 = L["Group"].." 4:"
AGB_LOCALS.g5 = L["Group"].." 5:"
AGB_LOCALS.g6 = L["Group"].." 6:"
AGB_LOCALS.g7 = L["Group"].." 7:"
AGB_LOCALS.g8 = L["Group"].." 8:"

AGB_LOCALS.close = L["Close"]
AGB_LOCALS.priest = BC["Priest"]
AGB_LOCALS.paladin = BC["Paladin"]
AGB_LOCALS.mage = BC["Mage"]
AGB_LOCALS.druid = BC["Druid"]

AGB_RAIDLIST = {}
AGB_RAIDLIST.Priest = {}
AGB_RAIDLIST.Druid = {}
AGB_RAIDLIST.Mage = {}
AGB_RAIDLIST.Paladin = {}


function AceBuffGroup:druidReset()
	for i=1, 8 do
		local gotwtmp = "AGBMainWindowDruidWindowGroup" .. i .."GotwDropDown";
		AceBuffGroupDB.Druid[i] = nil
		UIDropDownMenu_SetText(nil, getglobal(gotwtmp));
	end
end
function AceBuffGroup:priestReset()
	for i=1, 8 do
		local staminatmp = "AGBMainWindowPriestWindowGroup" .. i .."StaminaDropDown";
		local spirittmp = "AGBMainWindowPriestWindowGroup" .. i .."SpiritDropDown";
		local shadowtmp = "AGBMainWindowPriestWindowGroup" .. i .."ShadowDropDown";
		AceBuffGroupDB.Priest.Stamina[i] = nil
		AceBuffGroupDB.Priest.Spirit[i] = nil
		AceBuffGroupDB.Priest.Shadow[i] = nil
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Stamina[i], getglobal(staminatmp));
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Spirit[i], getglobal(spirittmp));
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Shadow[i], getglobal(shadowtmp));
	end
end
function AceBuffGroup:mageReset()
	for i=1, 8 do
		local aitmp = "AGBMainWindowMageWindowGroup" .. i .."AIDropDown";
		AceBuffGroupDB.Mage[i] = nil
		UIDropDownMenu_SetText(AceBuffGroupDB.Mage[i], getglobal(aitmp));
	end
end

function AceBuffGroup:paladinReset()
		AceBuffGroupDB.Paladin[1] = nil
		AceBuffGroupDB.Paladin[2] = nil
		AceBuffGroupDB.Paladin[3] = nil
		AceBuffGroupDB.Paladin[4] = nil
		AceBuffGroupDB.Paladin[5] = nil
		AceBuffGroupDB.Paladin[6] = nil
		AceBuffGroupDB.Paladin[7] = nil
		AceBuffGroupDB.Paladin[8] = nil
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[1],AGBMainWindowPaladinWindowBOKDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[2],AGBMainWindowPaladinWindowBOWDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[3],AGBMainWindowPaladinWindowBOMDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[4],AGBMainWindowPaladinWindowBOSALDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[5],AGBMainWindowPaladinWindowBOSANDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[6],AGBMainWindowPaladinWindowBOLDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[7],AGBMainWindowPaladinWindowSOWDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[8],AGBMainWindowPaladinWindowSOLDropDown);
end

function AceBuffGroup:CHAT_MSG_ADDON()
	-- msg from AceBuffGroups:
	local number
	local name
	local drop
	local inlist = 1;
	if arg1 == "ACEBUFFGROUPS" then
	-- Spirit Antwort
	if(arg2 == "ASPI") then
		for v in pairs(AGB_HASSPIRIT) do
			if v == arg4 then
				inlist = nil
				break;
			end
		end  
		if inlist then
			AGB_HASSPIRIT[table.getn(AGB_HASSPIRIT)+1] = arg4;
		end
	end  
	-- Spirit Abfrage
	if(arg2 == "QSPI") then
		if schedule then
			local currentRank;
			_, _, _, _, currentRank, _, _, _ = GetTalentInfo(1, 14);
			if currentRank == 1 then
				SendAddonMessage("ACEBUFFGROUPS", "ASPI", "RAID");
				schedule = nil
				metro:Start("QSPIT");
			end
		end
	end                     
		-- Stamina
		if string.find(arg2, "Stamina") then
			for num in string.gmatch(arg2, "(%d)") do
       	number =  num;
     	end
     	if string.find(arg2, "_null") then
					name = nil
			else
				for tmp in string.gmatch(arg2, "Stamina"..number.."(.+)") do
					name = tmp
					
				end
			end
			-- set the text
			if name then
				local drop = "AGBMainWindowPriestWindowGroup" .. number .."StaminaDropDown"
				UIDropDownMenu_SetText(name, getglobal(drop));
			end
		end
		-- Spirit
		if string.find(arg2, "Spirit") then
			for num in string.gmatch(arg2, "(%d)") do
       	number =  num;
     	end
     	if string.find(arg2, "_null") then
					name = nil
			else
				for tmp in string.gmatch(arg2, "Spirit"..number.."(.+)") do
					name = tmp
					
				end
			end
			-- set the text
			if name then
				local drop = "AGBMainWindowPriestWindowGroup" .. number .."SpiritDropDown"
				UIDropDownMenu_SetText(name, getglobal(drop));
			end
		end
		-- Shadow
		if string.find(arg2, "Shadow") then
			for num in string.gmatch(arg2, "(%d)") do
       	number =  num;
     	end
     	if string.find(arg2, "_null") then
					name = nil
			else
				for tmp in string.gmatch(arg2, "Shadow"..number.."(.+)") do
					name = tmp
					
				end
			end
			-- set the text
			if name then
				local drop = "AGBMainWindowPriestWindowGroup" .. number .."ShadowDropDown"
				UIDropDownMenu_SetText(name, getglobal(drop));
			end
		end
		-- Arcane Intellect
		if string.find(arg2, "ArcaneIntellect") then
			for num in string.gmatch(arg2, "(%d)") do
       	number =  num;
     	end
     	if string.find(arg2, "_null") then
					name = nil
			else
				for tmp in string.gmatch(arg2, "ArcaneIntellect"..number.."(.+)") do
					name = tmp
					
				end
			end
			-- set the text
			if name then
				local drop = "AGBMainWindowMageWindowGroup" .. number .."AIDropDown"
				UIDropDownMenu_SetText(name, getglobal(drop));
			end
		end
		-- Gotw
		if string.find(arg2, "Gotw") then
			for num in string.gmatch(arg2, "(%d)") do
       	number =  num;
     	end
     	if string.find(arg2, "_null") then
					name = nil
			else
				for tmp in string.gmatch(arg2, "Gotw"..number.."(.+)") do
					name = tmp
					
				end
			end
			-- set the text
			if name then
				local drop = "AGBMainWindowDruidWindowGroup" .. number .."GotwDropDown"
				UIDropDownMenu_SetText(name, getglobal(drop));
			end
		end
		if string.find(arg2, "BOK") then
			for tmp in string.gmatch(arg2, "BOK(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOKDropDown);
		end
		if string.find(arg2, "BOW") then
			for tmp in string.gmatch(arg2, "BOW(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOWDropDown);
		end
		if string.find(arg2, "BOM") then
			for tmp in string.gmatch(arg2, "BOM(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOMDropDown);
		end
		if string.find(arg2, "BOSAL") then
			for tmp in string.gmatch(arg2, "BOSAL(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOSALDropDown);
		end
		if string.find(arg2, "BOSAN") then
			for tmp in string.gmatch(arg2, "BOSAN(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOSANDropDown);
		end
		if string.find(arg2, "BOL") then
			for tmp in string.gmatch(arg2, "BOL(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowBOLDropDown);
		end
		if string.find(arg2, "SOW") then
			for tmp in string.gmatch(arg2, "SOW(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowSOWDropDown);
		end
		if string.find(arg2, "SOL") then
			for tmp in string.gmatch(arg2, "SOL(.+)") do
					name = tmp
			end
			if string.find(arg2, "_null") then 
				name = nil
			end
			UIDropDownMenu_SetText(name,AGBMainWindowPaladinWindowSOLDropDown);
		end
	end
end
function AceBuffGroup:Disable()
	schedule = 1
	metro:Stop("QSPIT")
end
function AceBuffGroup:OnEnable()
	AceBuffGroup:GetSpirit();
	metro:Register("QSPIT", function() AceBuffGroup:Disable(); end, 3)
	metro:Register("PRANDOM", function() AceBuffGroup:PriestRandom1(); end, 3)
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("CHAT_MSG_ADDON")
	  
	for i=1, 8 do
		local gotwtmp = "AGBMainWindowDruidWindowGroup" .. i .."GotwDropDown";
		UIDropDownMenu_SetText(AceBuffGroupDB.Druid[i], getglobal(gotwtmp));
		local aitmp = "AGBMainWindowMageWindowGroup" .. i .."AIDropDown";
		UIDropDownMenu_SetText(AceBuffGroupDB.Mage[i], getglobal(aitmp));
		local staminatmp = "AGBMainWindowPriestWindowGroup" .. i .."StaminaDropDown";
		local spirittmp = "AGBMainWindowPriestWindowGroup" .. i .."SpiritDropDown";
		local shadowtmp = "AGBMainWindowPriestWindowGroup" .. i .."ShadowDropDown";
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Stamina[i], getglobal(staminatmp));
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Spirit[i], getglobal(spirittmp));
		UIDropDownMenu_SetText(AceBuffGroupDB.Priest.Shadow[i], getglobal(shadowtmp));
	end
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[1],AGBMainWindowPaladinWindowBOKDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[2],AGBMainWindowPaladinWindowBOWDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[3],AGBMainWindowPaladinWindowBOMDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[4],AGBMainWindowPaladinWindowBOSALDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[5],AGBMainWindowPaladinWindowBOSANDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[6],AGBMainWindowPaladinWindowBOLDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[7],AGBMainWindowPaladinWindowSOWDropDown);
		UIDropDownMenu_SetText(AceBuffGroupDB.Paladin[8],AGBMainWindowPaladinWindowSOLDropDown);
end
function AceBuffGroup:RAID_ROSTER_UPDATE()
	fillList();
end
function AceBuffGroup:OnShowDialog()
	local r, g, b = BC:GetColor("Druid");
	AGBMainWindowDruidColor:SetTexture(r,g,b, 1.0);
	local r, g, b = BC:GetColor("Mage");
	AGBMainWindowMageColor:SetTexture(r,g,b, 0.3);
	local r, g, b = BC:GetColor("Paladin");
	AGBMainWindowPaladinColor:SetTexture(r,g,b, 0.3);
	local r, g, b = BC:GetColor("Priest");
	AGBMainWindowPriestColor:SetTexture(r,g,b, 0.3);
end

function AceBuffGroup:SetHighlightDruid()
	local r, g, b = BC:GetColor("Druid");
	AGBMainWindowDruidColor:SetTexture(r,g,b, 1.0);
	AGBMainWindowDruidLabel:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end
function AceBuffGroup:SetDisabledDruid()
	local r, g, b = BC:GetColor("Druid");
	AGBMainWindowDruidColor:SetTexture(r,g,b, 0.3);
	AGBMainWindowDruidLabel:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
end

function AceBuffGroup:SetHighlightMage()
	local r, g, b = BC:GetColor("Mage");
	AGBMainWindowMageColor:SetTexture(r,g,b, 1.0);
	AGBMainWindowMageLabel:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end
function AceBuffGroup:SetDisabledMage()
	local r, g, b = BC:GetColor("Mage");
	AGBMainWindowMageColor:SetTexture(r,g,b, 0.3);
	AGBMainWindowMageLabel:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
end

function AceBuffGroup:SetHighlightPaladin()
	local r, g, b = BC:GetColor("Paladin");
	AGBMainWindowPaladinColor:SetTexture(r,g,b, 1.0);
	AGBMainWindowPaladinLabel:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end
function AceBuffGroup:SetDisabledPaladin()
	local r, g, b = BC:GetColor("Paladin");
	AGBMainWindowPaladinColor:SetTexture(r,g,b, 0.3);
	AGBMainWindowPaladinLabel:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
end
function AceBuffGroup:SetHighlightPriest()
	local r, g, b = BC:GetColor("Priest");
	AGBMainWindowPriestColor:SetTexture(r,g,b, 1.0);
	AGBMainWindowPriestLabel:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end
function AceBuffGroup:SetDisabledPriest()
	local r, g, b = BC:GetColor("Priest");
	AGBMainWindowPriestColor:SetTexture(r,g,b, 0.3);
	AGBMainWindowPriestLabel:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
end



function AceBuffGroup:SetWindowActive(state)
	IsWindowActive = state
end

function fillList()
local a, b, c , d;
a = 1
b = 1
c = 1
d = 1
	for i = 1, GetNumRaidMembers() do
		local name, _, _, _, class, _, _, _, _ = GetRaidRosterInfo(i);
		if( class == BC["Priest"] ) then
			AGB_RAIDLIST.Priest[a] = name;
			a = a + 1
		elseif( class == BC["Druid"]) then
			AGB_RAIDLIST.Druid[b] = name;
			b = b + 1
		elseif( class == BC["Mage"]) then
			AGB_RAIDLIST.Mage[c] = name;
			c = c + 1
		elseif( class == BC["Paladin"]) then
			AGB_RAIDLIST.Paladin[d] = name;
			d = d + 1
		end
	end
end

function AceBuffGroup:SendABGMessage(msg, channel)
	if(string.upper(channel) == "RAID")  then
		SendChatMessage(msg, "RAID");
	elseif( string.upper(channel) == "GUILD") then
		SendChatMessage(msg, "GUILD");
	elseif( string.upper(channel) == "PARTY" ) or ( string.upper(channel) == "GROUP")then
		SendChatMessage(msg, "PARTY");
	else
		local index = GetChannelName(channel)
		if index then 
  		SendChatMessage(msg , "CHANNEL", nil, index); 
		end
	end
		-- User did not input anything
		
	if not channel then
		DEFAULT_CHAT_FRAME:AddMessage("Please write your channel into the 'Channel Field'");
	end
end